const ZkClient = require('./lib/index').ZkClient;
const zkClient = new ZkClient({
    host: 'localhost',
    port: 2181,
    sessionTimeout: 120000 // 2 minute
});

(async () => {
    await zkClient.connect();
    
    // get root node children
    const children = await zkClient.getChildren('/');
    console.log(`Children of root node: ${JSON.stringify(children)}`);

    const nodeData = { status: 'active' };
    // now add a new node under root call jobs
    const exists = await zkClient.exists('/jobs');

    if (!exists) {
        await zkClient.create('/jobs', nodeData);
        // now get data as set on this new node
        const data = await zkClient.getData(newNode.znode);
    }

    // try to set new data
    await zkClient.setData('/jobs', nodeData);
    const data = await zkClient.getData('/jobs');

    // lock /jobs by adding a lock
    const tmpLock = await zkClient.create('/jobs/lock-', null, null, zkClient._createMode.PERSISTENT_SEQUENTIAL);

    /*
    zkClient.getChildren('/')
        .then(x => console.log(x))
        .catch(err => console.log(err));
    */

    try {
        const lock = await zkClient.acquireLock('/jobs');
        console.log('Lock acquired');

        await zkClient.releaseLock(lock);
    } catch(e) {
        console.log(`Failed to acquire lock on /jobs - Error: ${e}`);
    }

    //await zkClient.close();
    console.log('connected!');
})();
